"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = awaitTo;

/**
 * @param { Promise } promise
 * @param { Object= } errorExt - Additional Information you can pass to the err object
 * @return { Promise }
 */
function awaitTo(promise, errorExt) {
  return promise.then(function (data) {
    return [null, data];
  }).catch(function (err) {
    if (errorExt) {
      err = Object.assign(err, errorExt);
    }

    return [err];
  });
}